/*
** Copyright (C) 2003-2005 The Free Software Foundation.
**  
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**  
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**  
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
**  
*/


#include "libraries.h"
#include <glib.h>
#include "dialogprintproject2.h"
#include "utilities.h"
#include "bible.h"
#include "book.h"
#include "chapter.h"
#include "usfm.h"
#include "usfmtools.h"
#include <config.h> 
#include "xmlutils.h"
#include <time.h>


PrintProject2Dialog::PrintProject2Dialog (Scripture * scripture_in, Configuration * configuration_in)
{
  // Store data.
  scripture = scripture_in;
  configuration = configuration_in;

  printproject2dialog = gtk_dialog_new ();
  gtk_window_set_title (GTK_WINDOW (printproject2dialog), "Print project");
  gtk_window_set_position (GTK_WINDOW (printproject2dialog), GTK_WIN_POS_CENTER_ON_PARENT);
  gtk_window_set_modal (GTK_WINDOW (printproject2dialog), TRUE);
  gtk_window_set_destroy_with_parent (GTK_WINDOW (printproject2dialog), TRUE);
  gtk_window_set_type_hint (GTK_WINDOW (printproject2dialog), GDK_WINDOW_TYPE_HINT_DIALOG);

  dialog_vbox1 = GTK_DIALOG (printproject2dialog)->vbox;
  gtk_widget_show (dialog_vbox1);

  vbox1 = gtk_vbox_new (FALSE, 4);
  gtk_widget_show (vbox1);
  gtk_box_pack_start (GTK_BOX (dialog_vbox1), vbox1, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (vbox1), 5);
/*
  coverpagecheckbutton = gtk_check_button_new_with_mnemonic ("Print Cover Page (not yet implemented)");
  gtk_widget_show (coverpagecheckbutton);
  gtk_box_pack_start (GTK_BOX (vbox1), coverpagecheckbutton, FALSE, FALSE, 0);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (coverpagecheckbutton), configuration->printcoverpage);
  gtk_widget_set_sensitive (coverpagecheckbutton, FALSE);

  titlepagecheckbutton = gtk_check_button_new_with_mnemonic ("Print Title and Copyright Pages (not yet implemented)");
  gtk_widget_show (titlepagecheckbutton);
  gtk_box_pack_start (GTK_BOX (vbox1), titlepagecheckbutton, FALSE, FALSE, 0);
  gtk_widget_set_sensitive (titlepagecheckbutton, FALSE);

  introductioncheckbutton = gtk_check_button_new_with_mnemonic ("Print Introduction (not yet implemented)");
  gtk_widget_show (introductioncheckbutton);
  gtk_box_pack_start (GTK_BOX (vbox1), introductioncheckbutton, FALSE, FALSE, 0);
  gtk_widget_set_sensitive (introductioncheckbutton, FALSE);

  tablecontentscheckbutton = gtk_check_button_new_with_mnemonic ("Print Table of Contents (not yet implemented)");
  gtk_widget_show (tablecontentscheckbutton);
  gtk_box_pack_start (GTK_BOX (vbox1), tablecontentscheckbutton, FALSE, FALSE, 0);
  gtk_widget_set_sensitive (tablecontentscheckbutton, FALSE);

  ottitlecheckbutton = gtk_check_button_new_with_mnemonic ("Print Old Testament Title Page (not yet implemented)");
  gtk_widget_show (ottitlecheckbutton);
  gtk_box_pack_start (GTK_BOX (vbox1), ottitlecheckbutton, FALSE, FALSE, 0);
  gtk_widget_set_sensitive (ottitlecheckbutton, FALSE);

  table1 = gtk_table_new (3, 3, FALSE);
  gtk_widget_show (table1);
  gtk_box_pack_start (GTK_BOX (vbox1), table1, TRUE, TRUE, 0);
  gtk_table_set_row_spacings (GTK_TABLE (table1), 1);
  gtk_table_set_col_spacings (GTK_TABLE (table1), 3);

  label1 = gtk_label_new ("From");
  gtk_widget_show (label1);
  gtk_table_attach (GTK_TABLE (table1), label1, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label1), 1, 0.5);

  label2 = gtk_label_new ("To");
  gtk_widget_show (label2);
  gtk_table_attach (GTK_TABLE (table1), label2, 0, 1, 2, 3,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label2), 1, 0.5);

  combo_ot_book_to = gtk_combo_box_new_text ();
  gtk_widget_show (combo_ot_book_to);
  gtk_table_attach (GTK_TABLE (table1), combo_ot_book_to, 1, 2, 2, 3,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  combo_entry_ot_book_to = GTK_COMBO (combo_ot_book_to)->entry;
  gtk_widget_show (combo_entry_ot_book_to);
  gtk_entry_set_activates_default (GTK_ENTRY (combo_entry_ot_book_to), TRUE);

  combo_ot_chapter_from = gtk_combo_box_new_text ();
  gtk_widget_show (combo_ot_chapter_from);
  gtk_table_attach (GTK_TABLE (table1), combo_ot_chapter_from, 2, 3, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  combo_entry_ot_chapter_from = GTK_COMBO (combo_ot_chapter_from)->entry;
  gtk_widget_show (combo_entry_ot_chapter_from);
  gtk_widget_set_size_request (combo_entry_ot_chapter_from, 50, -1);
  gtk_entry_set_activates_default (GTK_ENTRY (combo_entry_ot_chapter_from), TRUE);

  combo_ot_chapter_to = gtk_combo_box_new_text ();
  gtk_widget_show (combo_ot_chapter_to);
  gtk_table_attach (GTK_TABLE (table1), combo_ot_chapter_to, 2, 3, 2, 3,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  combo_entry_ot_chapter_to = GTK_COMBO (combo_ot_chapter_to)->entry;
  gtk_widget_show (combo_entry_ot_chapter_to);
  gtk_widget_set_size_request (combo_entry_ot_chapter_to, 50, -1);
  gtk_entry_set_activates_default (GTK_ENTRY (combo_entry_ot_chapter_to), TRUE);

  otcheckbutton = gtk_check_button_new_with_mnemonic ("Print Old Testament Books (not yet implemented)");
  gtk_widget_show (otcheckbutton);
  gtk_table_attach (GTK_TABLE (table1), otcheckbutton, 0, 3, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_sensitive (otcheckbutton, FALSE);

  combo_ot_book_from = gtk_combo_box_new_text ();
  gtk_widget_show (combo_ot_book_from);
  gtk_table_attach (GTK_TABLE (table1), combo_ot_book_from, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  GList *combo_ot_book_from_items = NULL;
//  combo_ot_book_from_items = g_list_append (combo_ot_book_from_items, (gpointer) "Genesis");
//  combo_ot_book_from_items = g_list_append (combo_ot_book_from_items, (gpointer) "Exodus");
  gtk_combo_set_popdown_strings (GTK_COMBO (combo_ot_book_from), combo_ot_book_from_items);
  g_list_free (combo_ot_book_from_items);

  combo_entry_ot_book_from = GTK_COMBO (combo_ot_book_from)->entry;
  gtk_widget_show (combo_entry_ot_book_from);
  // gtk_entry_set_text (GTK_ENTRY (combo_entry_ot_book_from), "Genesis");
  gtk_entry_set_activates_default (GTK_ENTRY (combo_entry_ot_book_from), TRUE);

  nttitlecheckbutton = gtk_check_button_new_with_mnemonic ("Print New Testament Title Page (not yet implemented)");
  gtk_widget_show (nttitlecheckbutton);
  gtk_box_pack_start (GTK_BOX (vbox1), nttitlecheckbutton, FALSE, FALSE, 0);
  gtk_widget_set_sensitive (nttitlecheckbutton, FALSE);

  table2 = gtk_table_new (3, 3, FALSE);
  gtk_widget_show (table2);
  gtk_box_pack_start (GTK_BOX (vbox1), table2, TRUE, TRUE, 0);
  gtk_table_set_row_spacings (GTK_TABLE (table2), 1);
  gtk_table_set_col_spacings (GTK_TABLE (table2), 3);

  ntcheckbutton = gtk_check_button_new_with_mnemonic ("Print New Testament Books (not yet implemented)");
  gtk_widget_show (ntcheckbutton);
  gtk_table_attach (GTK_TABLE (table2), ntcheckbutton, 0, 3, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_sensitive (ntcheckbutton, FALSE);

  label3 = gtk_label_new ("From");
  gtk_widget_show (label3);
  gtk_table_attach (GTK_TABLE (table2), label3, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label3), 1, 0.5);

  label4 = gtk_label_new ("To");
  gtk_widget_show (label4);
  gtk_table_attach (GTK_TABLE (table2), label4, 0, 1, 2, 3,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label4), 1, 0.5);

  combo_nt_book_from = gtk_combo_box_new_text ();
  gtk_widget_show (combo_nt_book_from);
  gtk_table_attach (GTK_TABLE (table2), combo_nt_book_from, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  combo_entry_nt_book_from = GTK_COMBO (combo_nt_book_from)->entry;
  gtk_widget_show (combo_entry_nt_book_from);
  gtk_entry_set_activates_default (GTK_ENTRY (combo_entry_nt_book_from), TRUE);

  combo_nt_chapter_from = gtk_combo_box_new_text ();
  gtk_widget_show (combo_nt_chapter_from);
  gtk_table_attach (GTK_TABLE (table2), combo_nt_chapter_from, 2, 3, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  combo_entry_nt_chapter_from = GTK_COMBO (combo_nt_chapter_from)->entry;
  gtk_widget_show (combo_entry_nt_chapter_from);
  gtk_widget_set_size_request (combo_entry_nt_chapter_from, 50, -1);
  gtk_entry_set_activates_default (GTK_ENTRY (combo_entry_nt_chapter_from), TRUE);

  combo_nt_book_to = gtk_combo_box_new_text ();
  gtk_widget_show (combo_nt_book_to);
  gtk_table_attach (GTK_TABLE (table2), combo_nt_book_to, 1, 2, 2, 3,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  combo_entry_nt_book_to = GTK_COMBO (combo_nt_book_to)->entry;
  gtk_widget_show (combo_entry_nt_book_to);
  gtk_entry_set_activates_default (GTK_ENTRY (combo_entry_nt_book_to), TRUE);

  combo_nt_chapter_to = gtk_combo_box_new_text ();
  gtk_widget_show (combo_nt_chapter_to);
  gtk_table_attach (GTK_TABLE (table2), combo_nt_chapter_to, 2, 3, 2, 3,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  combo_entry_nt_chapter_to = GTK_COMBO (combo_nt_chapter_to)->entry;
  gtk_widget_show (combo_entry_nt_chapter_to);
  gtk_widget_set_size_request (combo_entry_nt_chapter_to, 50, -1);
  gtk_entry_set_activates_default (GTK_ENTRY (combo_entry_nt_chapter_to), TRUE);

  wordexplanationcheckbutton = gtk_check_button_new_with_mnemonic ("Print Words Explanation (not yet implemented)");
  gtk_widget_show (wordexplanationcheckbutton);
  gtk_box_pack_start (GTK_BOX (vbox1), wordexplanationcheckbutton, FALSE, FALSE, 0);
  gtk_widget_set_sensitive (wordexplanationcheckbutton, FALSE);
*/
  dialog_action_area1 = GTK_DIALOG (printproject2dialog)->action_area;
  gtk_widget_show (dialog_action_area1);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (dialog_action_area1), GTK_BUTTONBOX_END);

  cancelbutton1 = gtk_button_new_from_stock ("gtk-cancel");
  gtk_widget_show (cancelbutton1);
  gtk_dialog_add_action_widget (GTK_DIALOG (printproject2dialog), cancelbutton1, GTK_RESPONSE_CANCEL);
  GTK_WIDGET_SET_FLAGS (cancelbutton1, GTK_CAN_DEFAULT);

  okbutton1 = gtk_button_new_from_stock ("gtk-ok");
  gtk_widget_show (okbutton1);
  gtk_dialog_add_action_widget (GTK_DIALOG (printproject2dialog), okbutton1, GTK_RESPONSE_OK);
  GTK_WIDGET_SET_FLAGS (okbutton1, GTK_CAN_DEFAULT);
/*
  g_signal_connect ((gpointer) combo_entry_ot_book_to, "changed",
                    G_CALLBACK (on_combo_entry_ot_book_to_changed),
                    gpointer(this));
  g_signal_connect ((gpointer) combo_entry_ot_chapter_from, "changed",
                    G_CALLBACK (on_combo_entry_ot_chapter_from_changed),
                    gpointer(this));
  g_signal_connect ((gpointer) combo_entry_ot_chapter_to, "changed",
                    G_CALLBACK (on_combo_entry_ot_chapter_to_changed),
                    gpointer(this));
  g_signal_connect ((gpointer) otcheckbutton, "toggled",
                    G_CALLBACK (on_otcheckbutton_toggled),
                    gpointer(this));
  g_signal_connect ((gpointer) combo_entry_ot_book_from, "changed",
                    G_CALLBACK (on_combo_entry_ot_book_from_changed),
                    gpointer(this));
  g_signal_connect ((gpointer) ntcheckbutton, "toggled",
                    G_CALLBACK (on_ntcheckbutton_toggled),
                    gpointer(this));
  g_signal_connect ((gpointer) combo_entry_nt_book_from, "changed",
                    G_CALLBACK (on_combo_entry_nt_book_from_changed),
                    gpointer(this));
  g_signal_connect ((gpointer) combo_entry_nt_chapter_from, "changed",
                    G_CALLBACK (on_combo_entry_nt_chapter_from_changed),
                    gpointer(this));
  g_signal_connect ((gpointer) combo_entry_nt_book_to, "changed",
                    G_CALLBACK (on_combo_entry_nt_book_to_changed),
                    gpointer(this));
  g_signal_connect ((gpointer) combo_entry_nt_chapter_to, "changed",
                    G_CALLBACK (on_combo_entry_nt_chapter_to_changed),
                    gpointer(this));
*/                    
  g_signal_connect ((gpointer) okbutton1, "clicked",
                    G_CALLBACK (on_okbutton1_clicked),
                    gpointer(this));

  gtk_widget_grab_default (okbutton1);
  
}


PrintProject2Dialog::~PrintProject2Dialog ()
{
  gtk_widget_destroy (printproject2dialog);
}


int
PrintProject2Dialog::run ()
{
  return gtk_dialog_run (GTK_DIALOG (printproject2dialog));
}


void PrintProject2Dialog::
on_combo_entry_ot_book_to_changed      (GtkEditable     *editable,
                                        gpointer         user_data)
{

}


void PrintProject2Dialog::
on_combo_entry_ot_chapter_from_changed (GtkEditable     *editable,
                                        gpointer         user_data)
{

}


void PrintProject2Dialog::
on_combo_entry_ot_chapter_to_changed   (GtkEditable     *editable,
                                        gpointer         user_data)
{

}


void PrintProject2Dialog::
on_otcheckbutton_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{

}


void PrintProject2Dialog::
on_combo_entry_ot_book_from_changed    (GtkEditable     *editable,
                                        gpointer         user_data)
{

}


void PrintProject2Dialog::
on_ntcheckbutton_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{

}


void PrintProject2Dialog::
on_combo_entry_nt_book_from_changed    (GtkEditable     *editable,
                                        gpointer         user_data)
{

}


void PrintProject2Dialog::
on_combo_entry_nt_chapter_from_changed (GtkEditable     *editable,
                                        gpointer         user_data)
{

}


void PrintProject2Dialog::
on_combo_entry_nt_book_to_changed      (GtkEditable     *editable,
                                        gpointer         user_data)
{

}


void PrintProject2Dialog::
on_combo_entry_nt_chapter_to_changed   (GtkEditable     *editable,
                                        gpointer         user_data)
{

}


void PrintProject2Dialog::on_okbutton1_clicked (GtkButton *button, gpointer user_data)
{
  ((PrintProject2Dialog *) user_data)->on_okbutton ();
}


void PrintProject2Dialog::on_okbutton ()
{
//  configuration->printcoverpage = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (coverpagecheckbutton));
}
