/*
** Copyright (C) 2003-2005 The Free Software Foundation.
** ** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**  
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**  
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
**  
*/

#ifndef INCLUDED_UNDO_H
#define INCLUDED_UNDO_H

#include "libraries.h"
#include <gtk/gtk.h>


class Undo
{
public:
  Undo (int dummy);
  ~Undo ();
  void clear ();
  void on_insert (GtkTextIter *pos, const ustring & text, int bytes);
  void on_erase (GtkTextIter *range_begin, GtkTextIter *range_end);
  void undo (GtkTextBuffer *buffer);
  void redo (GtkTextBuffer *buffer);
  bool can_undo ();
  bool can_redo ();
private:
  vector <int> undo_position;
  vector <ustring> undo_text;
  vector <bool> undo_insert;
  void stack_operation (int position, const ustring& text, bool insert);
  bool non_undoable_action;
  unsigned int pointer;
};


#endif
